#coding:utf-8
import os
import subprocess
import sqlite3
import re
import time
import sys

#1.0.1 添加ntp服务器时间
#1.0.2 设置巨型帧
#1.0.3 删除过期文件(日志,失败包)
#1.0.4(1) 有usb转网口的时候，生成u2rj45name.txt，供主程序查阅
#(2)判断是否有网卡历史注册过ip，处理并使用注册信息,用于网卡掉线时保存ip
print("version 1.0.3 on %s" % time.strftime('%Y-%m-%d %H:%M:%S',time.localtime(time.time())))

#/proc
f = open("/proc/net/dev", "r")
str_cmd = f.read()
f.close()
listproc_cardname = re.findall("\s+(\S+):", str_cmd)

#获取mac和网卡名对应的字典
dict_mac2name = {}
for iproc in listproc_cardname:
    if iproc == "lo":
        continue
    macfile = "/sys/class/net/%s/address" % iproc
    fitem = open(macfile, "r")
    itemmac = fitem.read()
    fitem.close()
    itemmac = itemmac.strip("\n") #strip()可以去除头尾指定字符
    dict_mac2name[itemmac] = iproc

#获取是否有usb转网卡信息，生成标识文件,供主程序使用
str_u2rj45name = ""
try:
    os.system("rm -f ./cnt_net/u2rj45name.txt")
    back_info = subprocess.getoutput ("dmesg | grep -iE Ethernet | grep -iE ASIX | grep -iE usb")
    #back_info = "[    2.740225] cls_ax88179_178a 2-3:1.0 eth1: register 'cls_ax88179_178a' at usb-0000:00:14.0-3, ASIX AX88179 USB 3.0 Gigabit Ethernet, 00:0e:c6:c3:01:20"
    list_macget = re.findall("(([a-zA-Z0-9]{2}:){5}[a-zA-Z0-9]{2})", back_info, re.M)
    list_mac = []   #获取的usb转网卡的网卡mac列表
    for item in list_macget:
        list_mac.append(item[0])
    print("line-%s]:" % sys._getframe().f_lineno, "find usbmac:", list_mac)
    if len(list_mac) != 0:
        print("line-%s]:" % sys._getframe().f_lineno, "dict mac:name:", dict_mac2name)
        for item in list_mac:   #查找mac对应的网卡名拼接成字符串
            if item in dict_mac2name.keys():
                str_u2rj45name += dict_mac2name[item]
                str_u2rj45name += ";" 
        print("line-%s]:" % sys._getframe().f_lineno, "u2rj45name.txt", str_u2rj45name)
        #编写本次开机后的usb网卡名
        if len(str_u2rj45name) != 0:
            f = open("./cnt_net/u2rj45name.txt", "w+")
            f.write(str_u2rj45name)                  
            f.close()
except Exception as value:
    print("line-%s]:" % sys._getframe().f_lineno, value)

#interfaces 获取interfaces里的配置信息
fr = open("/etc/network/interfaces", "r")
interfaces_content = fr.read(1000)
listface_info = re.findall("(^auto\s(\S+)\n(\S+.*\n){0,4})", interfaces_content, re.M)  #re.M：^$标志将会匹配每一行
listface_cardname = []
mapfaces = {}
for item in listface_info:
    listface_cardname.append(item[1])
    mapfaces[item[1]] = item[0]
    
#samelist,otherlist
samelist = list(set(listface_cardname) & set(listproc_cardname))    #相同的已在interfaces里注册过的
otherlist = list(set(samelist) ^ set(listproc_cardname))     #多出的
print("line-%s]:" % sys._getframe().f_lineno, "samelist" ,samelist)
print("line-%s]:" % sys._getframe().f_lineno, "alllist" ,listproc_cardname)

#down --关闭所有网卡
for iproc in listproc_cardname:
    if iproc == "lo":
        continue
    cmd = "ifconfig " + iproc + " down"
    os.system(cmd)

class C_Netcard_Interfaces: #从interfaces信息解析出的网卡信息
    def __init__(self):
        self.name = ""
        self.info = ""
        self.session = ""
        self.ip = ""
        self.netmask = ""
        self.gateway = ""
        self.mac = ""
    def getdict(self):  #获取类成员列表
        return self.__dict__
    def setdict(self, dicts):
        for item in dicts.keys():
            if item == "name":
                self.name = dicts["name"]
            elif item == "info":
                self.info = dicts["info"]
            elif item == "session":
                self.session = dicts["session"]
            elif item == "ip":
                self.ip = dicts["ip"]
            elif item == "netmask":
                self.netmask = dicts["netmask"]
            elif item == "gateway":
                self.gateway = dicts["gateway"]
            elif item == "mac":
                self.mac = dicts["mac"]
    def getstr(self):
        strnew = "auto %s\n" % self.name
        strnew += "iface %s inet static\n" % self.name
        strnew += "address %s\n" % self.ip
        strnew += "netmask %s\n" % self.netmask
        strnew += "gateway %s\n" % self.gateway
        strnew += "\n"
        return strnew
    
#判断是否有确认过的网卡配置信息，（确认文件由主程序进行修改）
def f_chksave_cardinfo(ls_interfaces):
    file_registermac = "./cnt_net/registermac.txt"
    if os.path.exists(file_registermac) is False:
        return ls_interfaces
    f = open(file_registermac, "r")
    str_listinfo = f.read()
    f.close()
    #注册表制成字典
    listrg = re.findall("(.*)=(\S+);(\S+);(\S+)", str_listinfo, re.M)
    dictrg = {} #字典{'00:0e:c6:c3:01:20': ('00:0e:c6:c3:01:20', '192.168.70.123', '255.255.255.0', '192.168.70.1'), 
    for item in listrg:
        dictrg[item[0]] = item
    print("line-%s]:" % sys._getframe().f_lineno, "registinfo_dictrg", dictrg)
    #检索并生成C_Netcard_Interfaces类信息
    listface_info = re.findall("(^auto\s(\S+)\n.*\n"    \
    "^address\s(\d+.\d+.(\d+).\d+)\n" \
    "netmask (\S+)\n)"  \
    "gateway (\S+)\n", ls_interfaces, re.M)
    dictfaces = {}  #{ 'eth0': C_Netcard_Interfaces}
    #制作成类数据
    for item in listface_info:
        citem = C_Netcard_Interfaces()
        citem.name = item[1]
        citem.session = item[3]
        citem.info = item[0]
        citem.ip = item[2]
        citem.netmask = item[4]
        citem.gateway = item[5]
        #mac
        for rgkey_mac in dict_mac2name.keys():
            if dict_mac2name[rgkey_mac] == citem.name:
                citem.mac = rgkey_mac
        dictfaces[item[1]] = citem.getdict()
    print("line-%s]:" % sys._getframe().f_lineno, "C_Netcard_Interfaces", dictfaces)
    #字典{mac:session}
    dictfaces_mac2session = {}
    for item in dictfaces.keys():
        dictitem = dictfaces[item]
        dictfaces_mac2session[dictitem.get("mac")] = dictitem.get("session")
    #判断并修改有注册的ip信息
    for item in dictfaces.keys():
        dictitem = dictfaces[item]
        mac = dictitem.get('mac')
        if mac in dictrg.keys():    #找到了保存项
            registIP = dictrg[mac][1]
            if dictitem.get("ip") == registIP:  #已经相等不进行更多处理
                continue
            session = re.findall("\d+.\d+.(\d+).\d+", registIP)
            if len(session) != 1:
                continue
            #判断修改项使用网段是否已经被占用
            ismustmodify = True
            for macitem in dictfaces_mac2session.keys():
                if macitem == mac:
                    continue
                if dictfaces_mac2session[macitem] == session[0]:
                    ismustmodify = False
                    break
            if ismustmodify is True:
                print("line-%s]:" % sys._getframe().f_lineno, "modify_regist", dictitem.get("name"), "to", registIP)
                dictitem["ip"] = registIP
                dictitem["session"] = session[0]
                dictitem["netmask"] = dictrg[mac][2]
                dictitem["gateway"] = dictrg[mac][3]
                dictfaces[item] = dictitem
    #制作文件
    strfinal_faces = "auto lo\n"
    strfinal_faces += "iface lo inet loopback\n\n"
    for item in dictfaces.keys():
        dictitem = dictfaces[item]
        citem = C_Netcard_Interfaces()
        citem.setdict(dictitem)
        stritem = citem.getstr()
        strfinal_faces += stritem

    #如果有注册的确认ip，优先使用
    #再判断一次，是否有重复的网段，有的话进行修改
    return strfinal_faces

#写入到interfaces-------------------------
strfinal = ""
for same in samelist:
    strfinal += mapfaces[same]
    strfinal += "\n"
##赋予默认值
for other in otherlist:             
    listAlUse = re.findall("^auto\s\S+\n.*\n^address\s\d+.\d+.(\d+).\d+", strfinal, re.M)
    ilistAlUse = []
    for item in listAlUse:
        ilistAlUse.append(int(item))
    sx = 2
    for isx in range(2, 11):    #去重
        if isx in ilistAlUse:
            isx += 1
        else:
            sx = isx
            break     
    if "lo" in other:
        strfinal += "auto " + other + "\n"
        strfinal +=  "iface " + other + " inet loopback\n\n"   
        continue 
    elif "wlan" in other:
        continue
    else:
        strfinal += "auto " + other + "\n"
        strfinal += "iface " + other + " inet static\n"
        strfinal += "address 192.168." + str(sx)  + ".5\n"
        strfinal += "netmask 255.255.255.0\n"
        strfinal += "gateway 192.168." + str(sx)  + ".1\n\n"
#检查是否有保存的设置过的，进行检查矫正
try:
    strfinal_new = f_chksave_cardinfo(strfinal)
except Exception as value:
    print("line-%s]:" % sys._getframe().f_lineno, value)

f = open("./cnt_net/interfaces", "w+")
f.write(strfinal_new)                  
f.close()
os.system("mv ./cnt_net/interfaces /etc/network/interfaces") #move

#mac --判断mac地址是否有相同的，进行不保存修改
mapMac = {}
for iproc in listproc_cardname:
    if iproc == "lo":
        continue
    cmd = "cat /sys/class/net/%s/address" % iproc
    ret = subprocess.Popen(cmd, shell=True, stdout = subprocess.PIPE)
    str_b = ret.stdout.read()
    str_cmd = bytes.decode(str_b)
    mapMac[iproc] = str_cmd
listkey = list(mapMac.keys())

for keymapMac in listkey:
    need_while = 1
    need_modify = 0
    while need_while:
        need_while = 0
        item_value = mapMac[keymapMac]
        for ikeymapMac in listkey:
            if keymapMac == ikeymapMac:
                continue
            if item_value != mapMac[ikeymapMac]:
                continue
            same_mac = "%s" % item_value
            lastlist = same_mac.split(":")
            last = lastlist[-1]
            intx = int("%s" % last, 16)
            newintx = hex(intx + 1)
            str_netintx = "%s" % newintx
            str_netintx = str_netintx.split("x")[-1]
 
            if intx + 1 < 10:
                str_netintx = "0" + str_netintx
            elif intx + 1 > 255:
                str_netintx = str_netintx[-2:]    
            lastlist[-1] = str_netintx
            same_mac = ":".join(lastlist)
            mapMac[keymapMac] = same_mac + "\n"
            need_while = 1
            need_modify = 1
            break
        
    if need_modify == 1:    
        cmd = "ifconfig %s hw ether %s" % (keymapMac, same_mac)
        os.system(cmd)
        print(cmd)

#up
# for itemcard in listproc_cardname:
#     os.system("ifdown %s" % itemcard)   #wlan关不掉
#     os.system("ip addr flush dev %s" % itemcard)
#     os.system("ifup %s" % itemcard)
#     cmd = "ifconfig " + itemcard + " up"
#     os.system(cmd)
#     cmd = "ifconfig " + itemcard + " mtu 9000 || "    #巨针9000否执行4000
#     cmd += "ifconfig " + itemcard + " mtu 4000"
#     os.system(cmd)
#ifup/ifdown会导致socket联网无法正常使用，可能是interfaces里有路由器信息
listaddrmask = re.findall("^auto\s(\S+)\n.*\naddress\s((\d+.\d+.\d+.)\d+)\nnetmask\s(\d+.\d+.\d+.\d+)\n", strfinal_new, re.M)
for item in listaddrmask:
    cmd = "ifconfig " + item[0] + " up"
    os.system(cmd)
    cmd = "ifconfig %s %s netmask %s broadcast %s" % (item[0], item[1], item[3], item[2]+"255")
    os.system(cmd)
    cmd = "ifconfig " + item[0] + " mtu 9000 || "    #巨针9000否执行4000
    cmd += "ifconfig " + item[0] + " mtu 4000"
    os.system(cmd)
    
#up wlan
for iproc in listproc_cardname:
    if "wlan" in iproc:
        cmd = "ifconfig " + iproc + " up"
        os.system(cmd)
        print("up wlan")
        
#run ntp server
def ntpserver(sql):
    curs = sql.cursor()
    cursor_addr = curs.execute("SELECT 值 from info_sysconf where 信息名称='serverip_info'")
    addrpath = "null"
    for rowss in cursor_addr:
        addrpath = rowss[0]
    #sql.close()
    #创建/删除 是否校验时间的临时文件
    if not os.path.exists("use_chk_server_time"):
        if addrpath != "null":
            fp = open("use_chk_server_time", "w+")
            fp.write(addrpath)
            fp.close
        
#remove overdue file 5 删除5天前的一些文件
def remove_overfile(sql):
    try:
        curs = sql.cursor()
        int_curtime = int(time.time())
        list_path = []
        #日志文件
        logpath = "null"
        cursor_name = curs.execute("SELECT 值 from info_sysconf where 信息名称='logpath'")
        for row in cursor_name:
            logpath = row[0]
        str_logpath = "%s" % logpath
        if str_logpath == "null":
            raise Exception("filepath is not full")
        list_path.append(str_logpath) 
        #application
        list_path.append("/root/bin-AOI/cnt_net/cnt_log_app/")
        #失败文件
        cursor_name = curs.execute("SELECT 值 from info_sysconf where 信息名称='failpath'")
        for row in cursor_name:
            failpath = row[0]
        str_failpath = "%s" % failpath
        if str_failpath == "null":
            raise Exception("filepath is not full")
        list_path.append(str_failpath) 
        
        #remove
        for item_path in list_path:
            for root, dirs, files in os.walk(item_path):
                for itemfile in files:
                    if root[-1] != "/":
                        root += "/"
                    file = root + itemfile
                    i_time = os.path.getmtime(file)
                    int_time = int(i_time)
                    differ = int_curtime - int_time
                    if differ > 5 * 24 * 60 * 60 :#5 days
                        os.remove(file)
    except Exception as value:
        print(value)
        
#删除指定文件，当期达到一定大小时
def remove_appointfile():
    try:
        list_filename = {}  #name:maxsize
        list_filename["./cnt_net/pylog.log"] = 5000000  #5M
        for itemname in list_filename.keys():
            if os.path.exists(itemname) is True:
                size = os.path.getsize(itemname)
                maxsize = list_filename[itemname]
                if size > maxsize:
                    os.remove(itemname)
                    print("remove oversides")
                    
    except Exception as value:
        print(value)


#------------------------------------- 
#网关及wifi设置
try:
    sql = sqlite3.connect("./PARAM.db")
    curs = sql.cursor()
    infouse = 0
    cursor_name = curs.execute("select value from sysparam where name='CntNet_UseName'")
    for row in cursor_name:
        info = row[0]
    cursor_use = curs.execute("select value from sysparam where name='CntNet'")
    for srow in cursor_use:
        infouse = srow[0]
        break
    strinfouse = "%s" % infouse
    for itemstrinfouse in strinfouse:
        infouse = itemstrinfouse
        break
    strname = "%s" % info
    strinfouse = "%s" % infouse
    sql.close()
    
    #创建/删除 是否校验时间的临时文件
    if os.path.exists("use_chk_server_time"):
        os.remove("use_chk_server_time")
        
    if strname == "" or strinfouse == "0":    #有确定使用联网网卡 和 使用联网
        raise Exception("no need use net or no such use card")
    
    if strname not in listproc_cardname:
        raise Exception("card %s not in /proc list" % strname)
    
    if "wlan" not in strname: 
        gateway = "null"
        touch = "^auto\s%s\n(.*\n){3}gateway\s(\d+.\d+.\d+.\d+)\n" % strname
        listUsecard = re.findall(touch, strfinal_new, re.M)
        if len(listUsecard):
            gateway = listUsecard[0][1]

        if gateway == "null":
            raise Exception("find interfaces netcard route error")
        
        backstate = os.system("route add default gw %s" % gateway)
        #base
        fb = open("./cnt_net/base", "w+")
        fb.write("nameserver %s\n" % gateway)
        fb.close()
        os.system("mv ./cnt_net/base /etc/resolvconf/resolv.conf.d/base")
    else:
        os.system("wpa_supplicant -i%s -Dwext -c /etc/wpa_supplicant/wlanpwd.conf &" % strname)
        #os.system("ifconfig %s %s" % (strname, address))
        os.system("dhclient %s &" % strname)
        #os.system("route add default gw %s" % gateway)
        os.system("rm /etc/resolvconf/resolv.conf.d/base")
    
    sql_net = sqlite3.connect("./cnt_net/sysconf.db")
    #获取服务器连接ntp
    ntpserver(sql_net)
    #删除过期文件
    remove_overfile(sql_net)
    #删除指定文件，当期达到一定大小时
    remove_appointfile()
    sql_net.close()

except sqlite3.OperationalError:
    print("cls：can not find sqlitefile")
except Exception as value:
    print(value)
except NameError:
    print("cls：some param error in db")
finally:
    print("up finish")















